package jdk.management.resource;

import java.util.stream.Stream;
import jdk.management.resource.internal.SimpleResourceContext;

public interface ResourceContext extends AutoCloseable
{
    public abstract void close();
    
    public abstract String getName();
    
    default public ResourceContext bindThreadContext() {
        throw new UnsupportedOperationException("bind not supported by " + this.getName());
    }
    
    public static ResourceContext unbindThreadContext() {
        return SimpleResourceContext.unbindThreadContext();
    }
    
    default public Stream<Thread> boundThreads() {
        throw new UnsupportedOperationException("boundThreads not supported by " + this.getName());
    }
    
    public abstract ResourceRequest getResourceRequest(ResourceType p0);
    
    default public void addResourceMeter(ResourceMeter resourceMeter) {
        throw new UnsupportedOperationException("addResourceMeter not supported by " + this.getName());
    }
    
    default public boolean removeResourceMeter(ResourceMeter resourceMeter) {
        throw new UnsupportedOperationException("removeResourceMeter not supported by " + this.getName());
    }
    
    public abstract ResourceMeter getMeter(ResourceType p0);
    
    public abstract Stream<ResourceMeter> meters();
    
    default public void requestAccurateUpdate(ResourceAccuracy resourceAccuracy) {
        throw new UnsupportedOperationException("requestAccurateUpdate not supported by " + this.getName());
    }
}
